<?php
/**
 * @file
 * Theme functions for Views Slideshow: RoyalSlider.
 */

/**
 * Theme function for RoyalSlider Views Slideshow main frame.
 *
 * @see views_slideshow_royalslider_theme()
 */
function theme_views_slideshow_royalslider_main_frame($variables) {
  // We need to re-write the rows into an array the RoyalSlider theme function
  // can handle.
  $items = array();

  for ($i = 0, $n = count($variables['rows']); $i < $n; ++$i) {
    $row = $variables['rows'][$i];
    $view_result = $variables['view']->result[$i];

    // We're only interested in the raw image data.
    $data = NULL;

    foreach ($view_result as $key => $value) {
      if (is_array($value)) {
        foreach ($value as $value2) {
          if (isset($value2['raw'])) {
            $data = $value2['raw'];
          }
        }
      }
    }

    // If we haven't found it yet, try to figure it out.
    // @TODO

    // Assume that everything except the image is a caption and override the
    // default image alt attribute with it.
    $caption = preg_replace("/<img[^>]+\>/i", "", $row);

    if (!empty($caption)) {
      $data['alt'] = $caption;
    }

    $items[] = $data;
  }

  $build = array(
    '#theme' => 'royalslider',
    '#royalslider_id' => $variables['vss_id'],
    '#optionset' => $variables['settings']['optionset'],
    '#skin' => $variables['settings']['skin'],
    '#items' => $items,
  );

  return drupal_render($build);
}
