<?php
/**
 * @file
 * Views Slideshow integration.
 */

/**
 * Implements hook_views_slideshow_slideshow_info().
 */
function views_slideshow_royalslider_views_slideshow_slideshow_info() {
  $options = array(
    'views_slideshow_royalslider' => array(
      'name' => t('RoyalSlider'),
      'accepts' => array(
//        'goToSlide',
//        'nextSlide',
//        'pause',
//        'play',
//        'previousSlide',
      ),
      'calls' => array(
//        'transitionBegin',
//        'transitionEnd',
//        'goToSlide',
//        'pause',
//        'play',
//        'nextSlide',
//        'previousSlide',
      ),
    ),
  );
  return $options;
}

/**
 * Implements hook_views_slideshow_skin_info().
 *
 * NOTE: Even though this would be really cool to implement like this, we're
 * persisting theme info in the optionsets so that it can be re-used by field
 * formatters and any other RoyalSlider implementation.
 */
//function views_slideshow_royalslider_views_slideshow_skin_info() {
//  return array(
//    'default' => array(
//      'name' => t('Default'),
//      'default-inverted' => t('Default Inverted'),
//      'minimal-white' => t('Minimal White'),
//      'universal' => t('Universal'),
//    ),
//  );
//}

/**
 *  Implements hook_views_slideshow_options_form().
 */
function views_slideshow_royalslider_views_slideshow_slideshow_type_form(&$form, &$form_state, &$view) {
  if (!$royalslider_path = _views_slideshow_royalslider_library_path()) {
    drupal_set_message(t('You need to install the RoyalSlider plugin. You can find the plugin at !url.', array('!url' => l('http://dimsemenov.com/plugins/royal-slider', 'http://dimsemenov.com/plugins/royal-slider', array('attributes' => array('target' => '_blank'))))), 'error');
  }

  $form['views_slideshow_royalslider']['intro'] = array(
    '#markup' => '<strong>' . t('Important') . ':</strong> ' . t('The RoyalSlider Views Slideshow plugin requires an image field to be added to the display (image styles will be overridden). Any extra fields will be joined together and treated as the caption. I realized this isn\'t ideal so please feel free to propose improvements in the issue queue.'),
  );

  // All settings stored in option sets.
  $form['views_slideshow_royalslider']['optionset'] = array(
    '#title' => t('Option Set'),
    '#description' => t('All RoyalSlider settings are stored in Option Sets.'),
    '#type' => 'select',
    '#options' => _royalslider_optionsets(),
  );

  // Allow the skin to be overridden per views slideshow instance.
  $form['views_slideshow_royalslider']['skin'] = array(
    '#title' => t('Skin'),
    '#description' => t('Override the Option Set\'s skin.'),
    '#type' => 'select',
    '#options' => _royalslider_skins(),
  );
}

function views_slideshow_royalslider_views_slideshow_option_definition() {
  $options['views_slideshow_royalslider'] = array(
    'contains' => array(
      'optionset' => array('default' => 'default'),
      'skin' => array('default' => 'default'),
    ),
  );

  return $options;
}

function views_slideshow_royalslider_form_options_js($element, &$form_state, &$form) {
  ctools_add_js('formoptions', 'views_slideshow_royalslider');
  return $element;
}
